#english
=begin
==NumRu::AdvancedDCL::Arrow
===About this module
Arrow module is for the arrow sub-primitives.
===Parameters
Name  Type  DCL package
:lprop(true or false)<SGPACK>
   Specifies whether the lines in the arrowhead is drawn proportional to the length of the arrow axis. When <TT>.TRUE.</TT>, the lines are proportional; when <TT>.FALSE.</TT>, the  lines are drawn at the constant value specified by the internal variable <TT>const</TT>, in a map projection, the lines are drawn at the constant specified by the internal variable <TT>constm</TT>. (Initial value: <TT>.TRUE.</TT>).
:luarw(true or false)<SGPACK>
   In a map projection, specifies whether the arrowhead is drawn fixed to the map. When <TT>.TRUE.</TT>, the arrowhead is fixed to the map; when <TT>.FALSE.</TT>, is drawn in VC. (Initial value: <TT>.TRUE.</TT>)
:afact(Float)<SGPACK>
   The proportionality factor used when <TT>lprop</TT> is <TT>.TRUE.</TT> (drawn proportionately) (Initial value: 0.33)
:const(Float)<SGPACK>
   The constant value used when <tt>lprop</tt> is <tt>.FALSE.</tt> (drawn at a fixed value) (Unit is <tt>VC</tt>; Initial value: 0.01)
:constm(Float)<SGPACK>
   The constant value used in a map projection when <TT>lprop</TT> is <TT>.FALSE. </TT>(drawn at a fixed value) (Unit is radians ;Initial value: 5.0)
:angle(Float)<SGPACK>
   The angle between the arrowhead and the arrow axis. (Unit is degrees; Initial value: 20.0)
:latone(true or false)<SGPACK>
   Specifies whether the triangular area of the arrowhead is filled solid. Filled when <TT>.TRUE.</TT>; Not filled when <TT>.FALSE.</TT>. (Initial value: <TT>.FALSE.</TT>)
:iatone(Fixnum)<SGPACK>
   The tone pattern for filling the triangular area of the arrowhead. (Initial value: 999) When the value is smaller than a 3-digit number, the color index specified for the axis will be used.
:arrowtype(Fixnum)<SGPACK::SGSLAT>
   The type of line drawn. This must have a value other than 0. When the value is 0, a message is printed, and no other steps are taken.
:arrowindex(Fixnum)<SGPACK::SGSLAI>
   The line index of a line segment. A value must be larger than 1. When the value is 0, a message is printed, and no other steps are taken. 
:rundef (float) <SYSLIB>
   Floating-point-number-type value indicating 'not specified'. (Initial value: -999.0)
:iundef (Fixnum) <SYSLIB>
   Integer-type value indicating 'not specified'. (Initial value: -999)
:lmiss (true or false) <SYSLIB>
   Specifies whether missing-value handling will be performed. Performed when true, and not performed when false. (Initial value: false).
:imiss (Fixnum) <SYSLIB>
   Specifies the integer-type missing value for missing-value handling. (Initial value: 999)
:rmiss (Float) <SYSLIB>
   Specifies the floating-point-number-type missing value for missing-value handling. (Initial value: 999.0)

In addition, These parameters can be used as methods. For example, it is possible to refer the parameter "lprop" with Arrow.lprop method. Moreover, it is possible to set the parameter "lprop" with Arrow.lprop= method.

=end

#japanese
=begin
==NumRu::AdvancedDCL::Arrow
==={W[ɂ
ArrowW[͒P̖t`߂̃W[łB
===p^
p^ p^̌^ ΉDCLpbP[W
:lprop(true or false)<SGPACK>
   蕔̐{̐̒̕ɔႳĕ`ǂw肷.TRUEȂႳĕ`; FALSEȂp^constŎw肵Ăl,n}êƂ̓p^constmŎw肵Ălŕ`(lTRUE).
:luarw(true or false)<SGPACK>
   n}êƂ, 蕔̐n}ɂւ΂悤ɕ`ǂw肷.TRUEȂn}ŕ`; FALSEȂVCŕ`(lTRUE).
:afact(Float)<SGPACK>
   lprop TRUE(Ⴓĕ`)̂Ƃɗp萔(l0.33).
:const(Float)<SGPACK>
   lpropFALSE(lŕ`)̂Ƃɗpl(PʂVC;l0.01).
:constm(Float)<SGPACK>
   lpropFALSE(lŕ`)łn}êƂɗpl(Pʂ͓x;l5.0).
:angle(Float)<SGPACK>
   蕔̐Ɩ{̐̂̕Ȃp(Pʂ͓x;l20.0).
:latone(true or false)<SGPACK>
   蕔`Op`̗̈hԂǂw肷.TRUEȂhԂ;FALSEȂhԂȂ(lFALSE).
:iatone(Fixnum)<SGPACK>
   蕔`Op`̗̈hԂ)̂Ƃ̃g[p^[(l999).3ȉ̂Ƃ, J[CfNX͎̕ɂĎw肳Ă̂p.
:arrowtype(Fixnum)<SGPACK::SGSLAT>
    C^Cvݒ肷. arrowtype0ȊOłȂ΂ȂȂ. arrowtype0̂Ƃ, bZ[W͏o͂邪ȂɂȂ. 
:arrowindex(Fixnum)<SGPACK::SGSLAI>
    CCfNXݒ肷. lineindex1ȏłȂ΂ȂȂ. lineindex0̂Ƃ, bZ[W͏o͂邪ȂɂȂ. 
:iundef (Fixnum) <SYSLIB>
   sł邱Ƃ^̒l(l-999)
:rundef (float) <SYSLIB>
   sł邱Ƃ^̒l(l-999.0)
:lmiss (true or false) <SYSLIB>
   lȂ ǂw肷. true Ȃ炨Ȃ, false Ȃ炨ȂȂ (l false).
:imiss (Fixnum) <SYSLIB>
   lȂƂ̐^̌lw肷 (l999).
:rmiss (Float) <SYSLIB>
   lȂƂ̎^̌lw肷 (l999.0).

܂Ãp^̓\bhƂėp邱ƂłBȂ킿AArrow.lpropŃp^lprop̎QƂAArrow.lprop=Ńp^lprop̕ύXłB

=end
module NumRu
  module AdvancedDCL
    module Arrow
      def param_init
	@param = Parameter.new(Common.param)
	@param.init("lprop", TrueClass, "sglset", "sglget", 0, 0)
	@param.init("luarw", TrueClass, "sglset", "sglget", 0, 0)
	@param.init("afact", Float, "sgrset", "sgrget", 0, 0)
	@param.init("const", Float, "sgrset", "sgrget", 0, 0)
	@param.init("constm", Float, "sgrset", "sgrget", 0, 0)
	@param.init("angle", Float, "sgrset", "sgrget", 0, 0)
	@param.init("latone", TrueClass, "sglset", "sglget", 0, 0)
	@param.init("iatone", Fixnum, "sgiset", "sgiget", 0, 0)
	
	@param.init("arrowtype", Fixnum, "sgslat", "sgqlat", 1, 1)
	@param.init("arrowindex", Fixnum, "sgslai", "sgqlai", 1, 1)

	@param.init("lmiss", TrueClass, "gllset", "gllget", 0, 0)
	@param.init("imiss", Fixnum, "gliset", "gliget", 0, 0)
	@param.init("rmiss", Float, "glrset", "glrget", 0, 0)
	@param.init("rundef", Float, "glrset", "glrget", 0, 0)
	@param.init("iundef", Fixnum, "gliset", "gliget", 0, 0)

	@temp_param = @param.dup
	@backup = @param.dup
	@orig_param = @param.dup
	@set = Hash.new
      end
      
      private :param_init
      
#------------------- method for parameters----------------------

      include Parameter_appli

# by kawanabe
#english
=begin
---Arrow.set(key, val)
   Sets parameters. If val is nil, the value of the parameter will return default value in DCL.

   Arguments
   * key: parameter name(String)
   * val: new value. About type, refer each parameter.

   Example
      Arrow.set("arrowindex", 3)      # Sets the arrow index 3.

=end
#japanese
=begin
---Arrow.set(key, val)
    p^̐ݒsBvalnilw肷ƒlDCLɂ鏉lɖ߂B

    
    * key:p^(String)
    * val:ݒ肷lB^͊ep^QƂ̂ƁB

    gp
        Arrow.set("arrowindex", 3)      # A[CfNX3ɐݒ

=end

# by kawanabe
#english
=begin
---Arrow.get(key)
    Refers the value of the parameter.

    Arguments
    * key: parameter name(String)

    Example
        Arrow.get("arrowindex")      # Refers the arrow index.

=end
#japanese
=begin
---Arrow.get(key)
    p^QƂB

    
    * key:p^(String)

    gp
        Arrow.get("arrowindex")      # A[CfNXQƂ

=end

# by kawanabe
#english
=begin
---Arrow.reset(key)
    Sets the value of the parameter default value.

    Arguments
    * key: parameter name(String)

    Example
        Arrow.reset("arrowindex")      # Sets the arrow index a default value.

=end
#japanese
=begin
---Arrow.reset(key)
    p^DCLɂ鏉lɖ߂B

    
    * key:p^(String)

    gp
        Arrow.reset("arrowindex")      # A[CfNXlɖ߂

=end

#english
=begin
---Arrow.help_params
    Refers available parameters in Arrow module.

    Arguments
    None

    Notes
    (1)This method return name of the parameter, present value, type of the parameter.

=end
#japanese
=begin
---Arrow.help_params
    ArrowŐݒ\ȃp^QƂB

    
    Ȃ

    l
    (1)̃\bh͐ݒ\ȃp^ɊւāAp^A݂̒lAp^̌^ԂB

=end

#english
=begin
---Arrow.sync
    Synchronizes the value of a parameter in DCL with the present value of the parameter in AdvancedDCL.

    Arguments
     None

    Notes
     In AdvancedDCL, parameters which set with "set" method do not synchronize with DCL and a method to synchronize parameters is called in drawing methods. This method is used to synchronize parameters with these of DCL directly.

=end 
#japanese
=begin
---Arrow.sync
    ݁Aݒ肳Ăp^DCLɔfB

    
     Ȃ

    l
     AdvancedDCLɂĂset\bĥ݂ł̓p^DCLɔfꂸA
p^sync郁\bhŌĂłB̃\bh̓[Up
^zsyncł邽߂̃\bhłB

=end

#------------ draw method ----------------------

      def draw(x1, y1, x2, y2, temp=nil)
	Basics.checkundef(x2.to_f, y2.to_f)
	@param.sync
	if(temp)
	   @temp_param.set(temp, @param, @backup)
	   @temp_param.sync
	end

	Fig.settrf
	
	DCL.sglau(x1, y1, x2, y2)
	if(temp)
	   @backup.sync
	   @temp_param.clear
	end

	nil
      end

# by DCL manual
#english
=begin
---Arrow.draw(x1, y1, x2, y2, temp=nil)
    Draws a line segment with an arrowhead in the U-coordinates.

    Arguments
    * x1, y1(Array or NArray):The coordinates of the beginning point of a line segment in UC.
    * x2, y2(Array or NArray):The coordinates of the end point of a line segment in UC.
    * temp:temporary parameters(Hash)

    Notes
    (1)SGLAU is called in this method.

=end 
#japanese
=begin
---Arrow.draw(x1, y1, x2, y2, temp=nil)
    UWnŖt`B

    
    * x1, y1(Array or NArray):UWnɂ̎n_̍W.
    * x2, y2(Array or NArray):UWnɂ̏I_̍W.
    * temp:e|p^(Hash)

    l
    (1)̃\bhSGLAUĂłB

=end

      def vdraw(x1, y1, x2, y2, temp=nil)
	@param.sync
	if(temp)
	   @temp_param.set(temp, @param, @backup)
	   @temp_param.sync
	end

	DCL.sglav(x1, y1, x2, y2)

	if(temp)
	   @backup.sync
	   @temp_param.clear
	end
	nil
      end

# by DCL manual
#english
=begin
---Arrow.vdraw(x1, y1, x2, y2, temp=nil)
    Draws a line segment with an arrowhead in the V-coordinates.

    Arguments
    * x1, y1(Array or NArray):The coordinates of the beginning point of a line segment in VC.
    * x2, y2(Array or NArray):The coordinates of the end point of a line segment in VC.
    * temp:temporary parameters(Hash)

    Notes
    (1)SGLAV is called in this method.

=end 
#japanese
=begin
---Arrow.vdraw(x1, y1, x2, y2, temp=nil)
    VWnŖt`B

    
    * x1, y1(Array or NArray):VWnɂ̎n_̍W.
    * x2, y2(Array or NArray):VWnɂ̏I_̍W.
    * temp:e|p^(Hash)

    l
    (1)̃\bhSGLAVĂłB

=end

      def rdraw(x1, y1, x2, y2, temp=nil)
	Basics.checkundef(x2.to_f, y2.to_f)
	@param.sync
	if(temp)
	   @temp_param.set(temp, @param, @backup)
	   @temp_param.sync
	end

	Fig.settrf
	DCL.sglar(x1, y1, x2, y2)

	if(temp)
	   @backup.sync
	   @temp_param.clear
	end
	nil
      end

# by DCL manual
#english
=begin
---Arrow.rdraw(x1, y1, x2, y2, temp=nil)
    Draws a line segment with an arrowhead in the R-coordinates.

    Arguments
    * x1, y1(Array or NArray):The coordinates of the beginning point of a line segment in RC.
    * x2, y2(Array or NArray):The coordinates of the end point of a line segment in RC.
    * temp:temporary parameters(Hash)

    Notes
    (1)SGLAR is called in this method.

=end 
#japanese
=begin
---Arrow.rdraw(x1, y1, x2, y2, temp=nil)
    RWnŖt`B

    
    * x1, y1(Array or NArray):RWnɂ̎n_̍W.
    * x2, y2(Array or NArray):RWnɂ̏I_̍W.
    * temp:e|p^(Hash)

    l
    (1)̃\bhSGLARĂłB

=end

      module_function :param_init
      module_function :help_params
      module_function :set
      module_function :get
      module_function :sync
      module_function :reset
      module_function :draw
      module_function :vdraw
      module_function :rdraw
      
      param_init

#----------------------------------------------------------

      @param.keys.each{|i|
	eval "def #{i}; @param['#{i}']; end"
	eval "def #{i}=(val); set('#{i}', val); end"
      }
      
      @param.keys.each{|i|
	eval "module_function :#{i}"
	eval "module_function :#{i}="
      }
    end
  end
end
