=begin
==NumRu::AdvancedDCL::Axis
:ireset(Fixnum)<USPACK>
   A variable for specifying the automatic resetting of parameters with <tt>USINIT</tt>. The initial value is 1.
:lxinv(true or false)<USPACK>
   Inverts the X axis (left-right) when true.
:lyinv(true or false)<USPACK>
   Inverts the Y axis (top-bottom) when true.
:lmatch(true or false)<USPACK>
   When true, the intervals of the labels and characters for the X and Y axis are set to be equal.
:rmrgn(Float)<USPACK>
   The width of a margin. Units in width of character (9.524).
:xfac*(Float)<USPACK>
   The value of the X axis factor (999).
:yfac*(Float)<USPACK>
   The value of the Y axis factor (999).
:xoff*(Float)<USPACK>
   The offset value of an uniform X axis (999).
:yoff*(Float)<USPACK>
   The offset value of an uniform Y axis (999).
:dxt*(Float)<USPACK>
   The interval of the tick marks for an uniform X axis (999).
:dyt*(Float)<USPACK>
   The interval of the tick marks for an uniform Y axis (999).
:dxl*(Float)<USPACK>
   The interval of the labels for an uniform X axis (999).
:dyl*(Float)<USPACK>
   The interval of the labels for an uniform Y axis (999).
:tfact(Float)<USPACK>
   The approximate interval of tick marks for an uniform coordinate system (2). A convenient value is selected for DUT, with an interval smaller than this value is multiplied by the character width.
:mxdgtx(Fixnum)<USPACK>
   The maximum number of digits in the label for the uniform X axis (4).
:mxdgty(Fixnum)<USPACK>
   The maximum number of digits in the label for the uniform Y axis (4). When the number of digits in the label exceed this value, set UOFF and UFAC so that the number of digits is lower than this value.
:nblank1(Fixnum)<USPACK>
   The minimum number of blanks between the labels when the labels are parallel to the axis. (Uniform coordinate system) (1).
:nblank2(Fixnum)<USPACK>
   The minimum number of blanks between the labels when the labels are perpendicular to the axis. (Uniform coordinate system) (2).
:nlblx*(Fixnum)<USPACK>
   The label format for a log X axis (999).
:nlbly*(Fixnum)<USPACK>
   The label format for a log Y axis (999).
:nticksx*(Fixnum)<USPACK>
   The number of ticks in a single order for a log X axis (999).
:nticksy*(Fixnum)<USPACK>
   The number of ticks in a single order for a log Y axis (999).
:itypex*(Fixnum)<USPACK>
   The type of log X axis (999).
:itypey*(Fixnum)<USPACK>
   The type of log Y axis (999).
:mxdgtsx(Fixnum)<USPACK>
   When the sub-labels for the X axis are drawn horizontally, they are drawn so that they do not exceed the range of character numbers for the label specified by mxdgtsx.
:mxdgtsy(Fixnum)<USPACK>
   When the sub-labels for the Y axis are drawn vertically, they are drawn so that they do not exceed the range of character numbers for the label specified by mxdgtsy.
:lprtct(true or false)<USPACK>
   Specifies that the sub-labels should not invade the label area for the other axis. When this is true, then the specifications in mxdgtsx/mxdgtsy are ignored.
:soffxtr*, soffxtl*, soffxbr*, soffxbl*, soffxur*, soffxul*(Float)<USPACK>
   The offset value of the X-axis sub-label. 
:soffytr*, soffyrb*, soffylt*, soffylb*, soffyut*, soffyub*(Float)<USPACK>
   The offset value of the Y-axis sub-label.
:xdtmax*, xdtmin*(Float)<USPACK>
   The maximum and minimum values of the X axis set by Fig.inclpoint.
:ydtmax*, ydtmin*(Float)<USPACK>
   The maximum and minimum values of the Y axis set by Fig.inclpoint.
:cxttl(String)<USPACK>
   The X- axis title (shorter than 32 characters)
:cyttl(String)<USPACK>
   The Y- axis title (shorter than 32 characters)
:cxfmt(String)<USPACK>
   >The X-axis label format. (Note 1)
:cyfmt(String)<USPACK>
   The Y-axis label format. (Note 1)
:cxside(String)<USPACK>
   The position to plot the X axis. You may specify this using up to 2 characters out of <tt>'T'(Top), 'B'(Bottom), 'U'(User)</tt>. Of the 2 characters specified, the subtitle and title is written in the position specified first. (Note 2)
:cyside(String)<USPACK>
   The position to plot the Y axis. You may specify this using up to 2 characters out of <tt>'R'(Right), 'L'(Left), 'U'(User)</tt>. Of the 2 characters specified, the subtitle and title is written in the position specified first. (Note 2)
:cxspos(String)<USPACK>
   The position to write the X-axis sub-label: 'R' or 'L'
:cyspos(String)<USPACK>
   The position to write the Y-axis sub-label: 'T' or 'B'
:cxunit(String)<USPACK>
   The unit to write in the X-axis sub-label (shorter than 32 characters)
:cyunit(String)<USPACK>
   The unit to write in the Y-axis sub-label (shorter than 32 characters)
:cblkt(String)<USPACK>
   The brackets for the sub-labels. The initial value is '()' When a blank is specified, no brackets are written.
:labelxb, labelxt, labelxu, labelyl, labelyr, labelyu(true or false)<UZPACK>
   An internal variable which specifies whether or not to draw labels. Labels drawn when <tt>.TRUE.</tt>; not drawn when false. (The initial values are true, false, true, true, false, true) 
:rsizet0, rsize1, rsize2 (Float)<UZPACK>
   An internal variable which specifies the length of the tick mark in units in VC. (The initial values are undefined, 0.007, and 0.014). 
:rsizel0, rsizel1, rsizel2 (Float)<UZPACK>
   An internal variable which specifies the character height of the characters of the label in units in VC. (The initial values are undefined, 0.021, and 0.028.)
:rsizec0, rsizec1, rsizec2 (Float)<UZPACK>
   An internal variable which specifies the character height of the characters of the title in units in VC. (The initial values are undefined, 0.028, and 0.035)
:uxuser(Float)<UZPACK>
   The value of the X coordinate which is used when '<tt>U</tt>'ser is specified as the parameter to specify position in the draw routine of the Y axis. (The initial value is undefined.)
:uyuser(Float)<UZPACK>
   The value of the Y coordinate which is used when '<tt>U</tt>'ser is specified as the parameter to specify position in the draw routine of the X axis. (The initial value is undefined.)
:irotl(zs) (Fixnum) <UZPACK>
   An internal variable which specifies the angle of rotation of the label text. The amount of rotation is specified using integer values when a unit of rotation is 90 degrees. (The initial values are 0, 0, 0, 0, 0, and 0.)
:irotc(zs) (Fixnum) <UZPACK>
   An internal variable which specifies the angle of rotation of the title text. The amount of rotation is specified using integer values when a unit of rotation is 90 degrees. (The initial values are 0, 0, 0, 0, 0, and 0.) 
:icent(zs) (Fixnum) <UZPACK>
   An internal variable which specifies the centering option of the label text. Left-aligned when -1, centered when 0, and right-aligned when +1. (The initial values are 0, 0, 0, +1, +1, and +1.)
:indext(i) (Fixnum) <UZPACK>
   An internal variable which specifies the line index of the line segment for drawing tick marks. (The initial values are undefined, 1, and 3.)
:indexl(i) (Fixnum) <UZPACK>
   An internal variable which specifies the line index of the line segment for characters in labels and text. (The initial values are undefined, 3, and 3.)
:loffset (true or false) <UZPACK>
   An internal variable which specifies whether or not to perform linear offset of the coordinate system. Offset when true; Not offset when false. (The initial value is false.)
:xoffset (Float) <UZPACK>
   An internal variable which specifies the amount of X axis offset when loffset is true. (The initial value is 0.0.)
:yoffset (Float) <UZPACK>
   An internal variable which specifies the amount of Y axis offset when loffset is true. (The initial value is 0.0.)
:xfact (Float) <UZPACK>
   An internal variable which specifies the value of the X axis factor when loffset is true. (The initial value is 1.0.)
:yfact (Float) <UZPACK>
   An internal variable which specifies the value of the Y axis factor when loffset is <tt>.TRUE.</tt>. (The initial value is 1.0.)
:pad1 (Float) <UZPACK>
   An internal variable which specifies the distance between the label and the axis component last drawn. (The initial value is 0.7 when the height of the label to be drawn is 1.)
:pad2 (Float) <UZPACK>
   An internal variable which is used when internally determining the amount of offset for the axis. (The initial value is 1.5, when the size of the internal variable rsizec2 is 1.)
:iflag (Fixnum) <UZPACK>
   An internal variable which specifies on which side of the axis the labels and titles are drawn when the parameter '<tt>U</tt>'ser is used in the axis settings. When iflag is positive, the labels are drawn above the axis for Axis::Lin.xplbl and on the right for Axis::Lin.yplbl. When iflag is negative, the labels are drawn on the opposite sides. (The initial value is -1. )
:lbtwn (true or false) <UZPACK>
   An internal variable which specifies the options for the position to draw the labels. When lbtwn is true, the labels are drawn in between the positions specified and when false, at the positions specified. (The initial value is false.)
:rbtwn (Float) <UZPACK>
   Specifies the detailed position of the label when the labels are drawn in between the positions specified (when lbtwn is true). Left-aligned when -1, centered when 0, right-aligned when +1. (The initial value is 0.0.)
:lbound (true or false) <UZPACK>
   Specifies whether to draw the title when the title exceeds the width of the viewport. Not drawn when true, drawn when false. (The initial value is false.)
:lbmsg (true or false) <UZPACK>
   Specifies whether to print an error message when lbound is true and there is not enough space for the title. Error message printed when true, not printed when false. (The initial value is true.)
:inner (Fixnum) <UZPACK>
   An internal variable which specifies on which side of the axis the tick marks are drawn. When inner is positive, the tick marks are drawn on the outside, and when negative, drawn on the inside. (The initial value is +1.)
:iundef (Float) <UZPACK>
   An internal variable which indicates that the value is undefined. (The initial value is -999.)
==NumRu::AdvancedDCL::Dateaxis
:nday (Fixnum) <UCPACK> 
   Specifies the interval for plotting tick marks and labels of dates when using Dateaxis.xady, Dateaxis.yady. If 'nday' is undefined, then an appropriate value is selected from 0, 1, 2, 5, 10, or 15. (When 0, only the axis is plotted, and no ticks or labels are drawn.) When explicitly specified, the specified value is used. (The initial value is undefined.) This value is specified by the DCL function 'NUCDAY'. 
:nchar (Fixnum) <UCPACK>
   Specifies the number of letters in the month for the label when using Dateaxis.xamn, Dateaxis.yamn. If 'nchar' is undefined, then an appropriate value is selected from 0, 1, 2, 3, or 9. (When 0, only the axis is plotted, and no ticks or months are drawn) When explicitly specified, the specified value is used. (The initial value is undefined.) This value is specified by the DCL function 'NUCCHR'. 
:lower (true or false) <UCPACK>
   Specifies whether to write the letters after the second letter in lower case for the name of the month written by Dateaxis.xady, Dateaxis.yady. In lower case when true; in upper case when false. (The initial value is false.)
:iundef (Fixnum) <UCPACK> 
   The internal variable indicating that the value is undefined. (The initial value is -999.)
==NumRu::AdvancedDCL::Contour
:indexmj (Fixnum) <UDPACK>
   >The line index of the major line. (The initial value is 3.)
:indexmn (Fixnum) <UDPACK>
   The line index of the minor line. (The initial value is 1.)
:label (true or false) <UDPACK>
   Specifies whether to place labels on major lines. Labeled when true not labeled when false. (The initial value is true)
:ldash (true or false) <UDPACK>
   Specifies whether to use different line types for drawing negative contour lines. When true, the negative contour lines are drawn with line type inquired by the internal variable 'idash'; when false, all contour lines are drawn with the line type inquired by the internal variable 'isolid'. (The initial value is true).
:idash (Fixnum) <UDPACK>
   The line type used for the negative contour level when 'ldash' is true. (The initial value is 3: dashed line.)
:isolid (Fixnum) <UDPACK>
   The line type used for contour levels with values larger than 0 when 'ldash'
:icycle (Fixnum) <UDPACK>
   Specifies the number of minor lines to drawn between major lines. One major line is drawn for a cycle of contour lines specified by the value inquired by 'icycle', and the remaining contour lines are minor lines. (The initial value is 2.)
:nlev (Fixnum) <UDPACK>
   When contour levels are automatically generated, this internal variable is inquired to generate nlev contour levels. (The initial value is 12.)
:labelsize (Float) <UDPACK>
   The character height of the contour label. (Units in VC; The initial value is undefined.) When this internal variable is undefined, the internal variable 'rsizel1' handled by Axis::Lin is inquired.
:lmsg (true or false) <UDPACK>
   Specifies whether to write a message in the bottom margin. Message printed when true, not printed when false. (The initial value is true)
:titlesize (Float) <UDPACK>
   The character height of the message printed in the bottom margin of the graph. (Units in VC; The initial value is undefined.) When this internal variable is undefined, the internal variable 'rsizel1' handled by Axis::Lin is inquired.
:xttl (Float) <UDPACK>
   An internal variable which determines the position of the message printed in the bottom margin of the graph. Takes a floating-point value between -1 to +1. Left-aligned when -1, centered when 0, and right-aligned when +1. (The initial value is 0.).
:labelfmt (String) <UDPACK::UDSFMT>
   Specifies the format of the contour label. For example, when you wish to make all contour labels integer types, then    
:iundef (Fixnum) <SYSLIB>
   Integer-type value indicating 'not specified'. (Initial value: -999)
:rundef (Float) <SYSLIB>
   Floating-point-number-type value indicating 'not specified'. (Initial value: -999.0)
:lmiss (true or false) <SYSLIB>
   Specifies whether missing-value handling will be performed. Performed when true, and not performed when false (Initial value: false).
:imiss (Fixnum) <SYSLIB>
   Specifies the integer-type missing value for missing-value handling. (Initial value: 999)
:rmiss (Float) <SYSLIB>
   Specifies the floating-point-number-type missing value for missing-value handling. (Initial value: 999.0)
==NumRu::AdvancedDCL::Arrow
:lprop(true or false)<SGPACK>
   Specifies whether the lines in the arrowhead is drawn proportional to the length of the arrow axis. When <TT>.TRUE.</TT>, the lines are proportional; when <TT>.FALSE.</TT>, the  lines are drawn at the constant value specified by the internal variable <TT>const</TT>, in a map projection, the lines are drawn at the constant specified by the internal variable <TT>constm</TT>. (Initial value: <TT>.TRUE.</TT>).
:luarw(true or false)<SGPACK>
   In a map projection, specifies whether the arrowhead is drawn fixed to the map. When <TT>.TRUE.</TT>, the arrowhead is fixed to the map; when <TT>.FALSE.</TT>, is drawn in VC. (Initial value: <TT>.TRUE.</TT>)
:afact(Float)<SGPACK>
   The proportionality factor used when <TT>lprop</TT> is <TT>.TRUE.</TT> (drawn proportionately) (Initial value: 0.33)
:const(Float)<SGPACK>
   The constant value used when <tt>lprop</tt> is <tt>.FALSE.</tt> (drawn at a fixed value) (Unit is <tt>VC</tt>; Initial value: 0.01)
:constm(Float)<SGPACK>
   The constant value used in a map projection when <TT>lprop</TT> is <TT>.FALSE. </TT>(drawn at a fixed value) (Unit is radians ;Initial value: 5.0)
:angle(Float)<SGPACK>
   The angle between the arrowhead and the arrow axis. (Unit is degrees; Initial value: 20.0)
:latone(true or false)<SGPACK>
   Specifies whether the triangular area of the arrowhead is filled solid. Filled when <TT>.TRUE.</TT>; Not filled when <TT>.FALSE.</TT>. (Initial value: <TT>.FALSE.</TT>)
:iatone(Fixnum)<SGPACK>
   The tone pattern for filling the triangular area of the arrowhead. (Initial value: 999) When the value is smaller than a 3-digit number, the color index specified for the axis will be used.
:arrowtype(Fixnum)<SGPACK::SGSLAT>
   The type of line drawn. This must have a value other than 0. When the value is 0, a message is printed, and no other steps are taken.
:arrowindex(Fixnum)<SGPACK::SGSLAI>
   The line index of a line segment. A value must be larger than 1. When the value is 0, a message is printed, and no other steps are taken. 
:rundef (float) <SYSLIB>
   Floating-point-number-type value indicating 'not specified'. (Initial value: -999.0)
:iundef (Fixnum) <SYSLIB>
   Integer-type value indicating 'not specified'. (Initial value: -999)
:lmiss (true or false) <SYSLIB>
   Specifies whether missing-value handling will be performed. Performed when true, and not performed when false. (Initial value: false).
:imiss (Fixnum) <SYSLIB>
   Specifies the integer-type missing value for missing-value handling. (Initial value: 999)
:rmiss (Float) <SYSLIB>
   Specifies the floating-point-number-type missing value for missing-value handling. (Initial value: 999.0)
==NumRu::AdvancedDCL::Bar
:frtype(Numeric)<UUPACK::UUSFRT>
   Specifies the line type of a frame. Specified attributes are used in Bar.frame,Box.frame methods.
:frindex(Numeric)<UUPACK::UUSFRI>
   Specifies the line index of a frame. Specified attributes are used in Bar.frame,Box.frame methods.
:barwidth(Numeric)<UUPACK::UUSBRS>
   Specifies the horizontal width of a bar graph. 
:lineindex(Numeric)<UUPACK::UUSLNI>
   Specifies the line index of a polyline
:linetype(Numeric)<UUPACK::UUSLNT>
   Specifies the line type of a polyline
:variablerange(Array[2, Numeric])<UUPACK::UUSIDV>
   Specifies the defined range of the independent variable. 
:uref(Float)<UUPACK>
   When the dependent variable is RUNDEF, the value of the internal variable uref (initial value = 0) is considered as specified.
:itpat(Array[2, Numeric])<UUPACK::UUSARP>
   Specifies the tone pattern for filling the internal area. The number set here is used by Gap.tone, Bar.tone, Box.tone. 
:iundef (Fixnum) <SYSLIB>
   Integer-type value indicating 'not specified'. (Initial value: -999)
:rundef (Float) <SYSLIB>
   Floating-point-number-type value indicating 'not specified'. (Initial value: -999.0)
:lmiss (true or false) <SYSLIB>
   Specifies whether missing-value handling will be performed. Performed when true, and not performed when false (Initial value: false).
:imiss (Fixnum) <SYSLIB>
   Specifies the integer-type missing value for missing-value handling. (Initial value: 999)
:rmiss (Float) <SYSLIB>
   Specifies the floating-point-number-type missing value for missing-value handling. (Initial value: 999.0)
==NumRu::AdvancedDCL::Box
:frtype(Numeric)<UUPACK::UUSFRT>
   Specifies the line type of a frame. Specified attributes are used in Bar.frame,Box.frame methods.
:frindex(Numeric)<UUPACK::UUSFRI>
   Specifies the line index of a frame. Specified attributes are used in Bar.frame,Box.frame methods.
:lineindex(Numeric)<UUPACK::UUSLNI>
   Specifies the line index of a polyline
:linetype(Numeric)<UUPACK::UUSLNT>
   Specifies the line type of a polyline
:variablerange(Array[2, Numeric])<UUPACK::UUSIDV>
   Specifies the defined range of the independent variable. 
:uref(Float)<UUPACK>
   When the dependent variable is RUNDEF, the value of the internal variable uref (initial value = 0) is considered as specified.
:itpat(Array[2, Numeric])<UUPACK::UUSARP>
   Specifies the tone pattern for filling the internal area. The number set here is used by Gap.tone, Bar.tone, Box.tone. 
:iundef (Fixnum) <SYSLIB>
   Integer-type value indicating 'not specified'. (Initial value: -999)
:rundef (Float) <SYSLIB>
   Floating-point-number-type value indicating 'not specified'. (Initial value: -999.0)
:lmiss (true or false) <SYSLIB>
   Specifies whether missing-value handling will be performed. Performed when true, and not performed when false (Initial value: false).
:imiss (Fixnum) <SYSLIB>
   Specifies the integer-type missing value for missing-value handling. (Initial value: 999)
:rmiss (Float) <SYSLIB>
   Specifies the floating-point-number-type missing value for missing-value handling. (Initial value: 999.0)
=end
